gb_version = "1.5"
gb_MessagesToHide = 0;
gb_Temp = ""
gb_Events = {
	"CHAT_MSG_GUILD",
	"CHAT_MSG_OFFICER",
	"CHAT_MSG_RAID",
	"CHAT_MSG_PARTY",
	"CHAT_MSG_SAY",
	"CHAT_MSG_YELL",
	"CHAT_MSG_WHISPER",
	"CHAT_MSG_WHISPER_INFORM",
	"CHAT_MSG_CHANNEL"
}
local chat_prefix = "[LootLinkBot]: "
local lColorSortTable = { };
lColorSortTable["ffff8000"] = 1;	-- legendary, orange
lColorSortTable["ffa335ee"] = 2;	-- epic, purple
lColorSortTable["ff0070dd"] = 3;	-- rare, blue
lColorSortTable["ff1eff00"] = 4;	-- uncommon, green
lColorSortTable["ffffffff"] = 5;	-- common, white
lColorSortTable["ff9d9d9d"] = 6;	-- poor, gray
lColorSortTable["ff40ffc0"] = 100;	-- unknown, teal

function gb_OnLoad()
	SLASH_GUILDBOT1 = "/lootlinkbot";
	SLASH_GUILDBOT2 = "/llb";
	SlashCmdList["GUILDBOT"] = gb_SlashCmd;
	gb_Register("VARIABLES_LOADED");
end

function gb_VarsLoaded()
	local index;
	local value;
	if (gb_Options == nil) then gb_Options = {}; end
	if (gb_Options["enabled"] == nil) then gb_Options["enabled"] = true; end
	if (gb_Options["MaxResults"] == nil) then gb_Options["MaxResults"] = 8; end
	if (gb_Options["HideMessages"] == nil) then gb_Options["HideMessages"] = true; end
	
	if (gb_Options["enabled"]) then
		gb_Register();
	end
	-- deletes german and french items and corrupt entries from the database --
	-- bugged?! t field is since 1.9 in many cases empty? ll bug? wtf?
	-- kkx ll fixed!
--[[	for index, value in ItemLinks do
		if (ItemLinks[index]["t"] and ItemLinks[index]["t"] ~= "") then
			if (not (string.find(ItemLinks[index]["t"], index, 1, 1))) then
				gb_AddMsg(index.." deleted")
				ItemLinks[index] = nil;			
			end
		else
			gb_AddMsg(index.." deleted")
			ItemLinks[index] = nil;
		end
	end --]] --bullshit deletes to much, deletes wrong items, sucks...
	
	gb_AddMsg("Loaded.");
	gb_Unregister("VARIABLES_LOADED");
end

function gb_SlashCmd(msg)
	msg = string.lower(msg);
	local _, _, argument1, argument2 = string.find(msg, "(%w+) (.+)");
	
		if (argument1 == nil) then
			argument1 = msg;
		end
		if (argument2 == nil) then
			argument2 = "";
		end
		
		if (argument1 == "on") then
			gb_Enable();
			gb_AddMsg("Enabled");
		elseif (argument1 == "off") then
			gb_Disable();
			gb_AddMsg("Disabled");
		else
			gb_AddMsg("Help");
			gb_AddMsg("/lootlinkbot on|off");			
			gb_AddMsg("You may use /llb instead of /lootlinkbot.");
		end
end

function gb_OnEvent(event)
	if (event == "VARIABLES_LOADED") then
		gb_VarsLoaded();
		return;
	end
	if (gb_Options["enabled"]) then
		if (string.find(event, "CHAT_MSG_[(%w)_]")) then
			if ((event == "CHAT_MSG_WHISPER") and (arg2 == UnitName("player"))) then
					return;
			end
			if (string.find(string.lower(arg1), "^!item")) then
				local SearchString, linkarray, chatchannel, player;
				SearchString = string.lower(string.gsub(arg1, "^!item ", ""));
				if ((SearchString == "") or (SearchString == nil) or ((string.gsub(SearchString, "(%s*)", "")) == "")) then
					local chatchannel = string.gsub(event, "CHAT_MSG_", "");
					if (chatchannel == "WHISPER_INFORM") then
						chatchannel = "WHISPER";
					end
					SendChatMessage("Syntax: !item name:<name> alltext:<full-text search> slot:<head/neck/shoulder...> rarity:<legendary/epic/rare...>", chatchannel, this.language, arg2);
					return;
				end
				if (SearchString == "help") then
					local chatchannel = string.gsub(event, "CHAT_MSG_", "");
					if (chatchannel == "WHISPER_INFORM") then
						chatchannel = "WHISPER";
					end				
					SendChatMessage("Syntax: !item name:<name> alltext:<full-text search> slot:<head/neck/shoulder...> rarity:<legendary/epic/rare...>", chatchannel, this.language, arg2);
					return;
				end
				if string.len(SearchString) < 3 then
					SendChatMessage("The search string must be at least 3 characters long.", "WHISPER", this.language, arg2);
					return;
				end
				if (not (string.find(SearchString, ":"))) then
				
					linkarray, chatchannel, player = gb_Search(SearchString, event, arg2);
					gb_SendResults(linkarray, chatchannel, player);
					
				else
				
					local SearchName, SearchAllText, SearchSlot, SearchRarity, SearchTemp;
					SearchString = string.gsub(SearchString, "name:(%s+)", "name:");
					SearchString = string.gsub(SearchString, "alltext:(%s+)", "alltext:");
					SearchString = string.gsub(SearchString, "fulltext:(%s*)", "alltext:");
					SearchString = string.gsub(SearchString, "full-text:(%s*)", "alltext:");
					SearchString = string.gsub(SearchString, "slot:(%s+)", "slot:");
					SearchString = string.gsub(SearchString, "location:(%s*)", "slot:");
					SearchString = string.gsub(SearchString, "rarity:(%s+)", "rarity:");
					
					if string.find(SearchString, "name:") then
						for SearchTemp in string.gfind(SearchString, "name:(.+)") do
							gb_Temp = SearchTemp;
						end						
						if (gb_Temp == nil) then gb_Temp = ""; end
						gb_Temp = string.gsub(gb_Temp, "alltext:(.*)", ""); 
						gb_Temp = string.gsub(gb_Temp, "slot:(.*)", ""); 
						gb_Temp = string.gsub(gb_Temp, "rarity:(.*)", ""); 
						SearchName = gb_Temp;
						gb_Temp = "";
					end
					
					if string.find(SearchString, "alltext:") then
						for SearchTemp in string.gfind(SearchString, "alltext:(.+)") do
							gb_Temp = SearchTemp;
						end						
						if (gb_Temp == nil) then gb_Temp = ""; end
						gb_Temp = string.gsub(gb_Temp, "rarity:(.*)", ""); 
						gb_Temp = string.gsub(gb_Temp, "slot:(.*)", ""); 
						gb_Temp = string.gsub(gb_Temp, "name:(.*)", ""); 
						SearchAllText = gb_Temp;
						gb_Temp = "";
					end
					
					if string.find(SearchString, "slot:") then
						for SearchTemp in string.gfind(SearchString, "slot:(.+)") do
							gb_Temp = SearchTemp;
						end						
						if (gb_Temp == nil) then gb_Temp = ""; end
						gb_Temp = string.gsub(gb_Temp, "alltext:(.*)", ""); 
						gb_Temp = string.gsub(gb_Temp, "rarity:(.*)", ""); 
						gb_Temp = string.gsub(gb_Temp, "name:(.*)", ""); 
						SearchSlot = gb_Temp;
						gb_Temp = "";
					end
					
					if string.find(SearchString, "rarity:") then
						for SearchTemp in string.gfind(SearchString, "rarity:(.+)") do
							gb_Temp = SearchTemp;
						end						
						if (gb_Temp == nil) then gb_Temp = ""; end
						gb_Temp = string.gsub(gb_Temp, "alltext:(.*)", ""); 
						gb_Temp = string.gsub(gb_Temp, "slot:(.*)", ""); 
						gb_Temp = string.gsub(gb_Temp, "name:(.*)", ""); 
						SearchRarity = gb_Temp;
						gb_Temp = "";
					end
				
				if (SearchName == nil) then SearchName = ""; end
				if (SearchAllText == nil) then SearchAllText = ""; end
				if (SearchSlot == nil) then SearchSlot = ""; end
				if (SearchRarity == nil) then SearchRarity = ""; end

				linkarray, chatchannel, player = gb_Search(nil, event, arg2, SearchAllText, SearchName, SearchRarity, SearchSlot);
				gb_SendResults(linkarray, chatchannel, player);
				
				end
				
			elseif (string.find(string.lower(arg1), "^!help")) then
				local chatchannel = string.gsub(event, "CHAT_MSG_", "");
				if (chatchannel == "WHISPER_INFORM") then
					chatchannel = "WHISPER";
				end			
				SendChatMessage("Syntax: !item name:<name> alltext:<full-text search> slot:<head/neck/shoulder...> rarity:<legendary/epic/rare...>", chatchannel, this.language, arg2);
			end			
		end
	end
end

function gb_Search(item, chatchannel, player, AllText, Name, Rarity, Slot)
	local chatchannel = string.gsub(chatchannel, "CHAT_MSG_", "");
	if (chatchannel == "WHISPER_INFORM") then
		chatchannel = "WHISPER";
	end
	local link;
	local iIterator = 0;
	local linkarray = {};

	if ((item) and (((Alltext) and (Name) and (Rarity) and (Slot)) == nil)) then		
		if ((item == nil) or (string.gsub(item, "(%s*)", " ") == " ")) then
				SendChatMessage("Syntax: !item name:<name> alltext:<full-text search> slot:<head/neck/shoulder...> rarity:<legendary/epic/rare...>", chatchannel, this.language, arg2);
				return;
		else
	
			for index, value in ItemLinks do				
				if string.find(string.lower(index), string.lower(item)) then
					if (GetItemInfo(gb_LLGetHyperlink(index))) then
						iIterator = iIterator + 1;
						linkarray[iIterator] = gb_LLGetLink(index);
					end
				end
			end
			table.sort (linkarray, gb_LLColorComparison);
			return linkarray, chatchannel, player;			
		end		
	else

		Name = string.gsub(Name, " $", "");
		AllText = string.gsub(AllText, " $", "");
		Rarity = string.gsub(Rarity, " $", "");
		Slot = string.gsub(Slot, " $", "");
--		gb_AddMsg(AllText..Name..Rarity..Slot);		
		if (string.lower(Rarity) == "legendary") or (Rarity == "ffff8000") then
			Rarity = "ffff8000";
		elseif (string.lower(Rarity) == "epic") or (Rarity == "ffa335ee") then
			Rarity = "ffa335ee";
		elseif (string.lower(Rarity) == "rare") or (Rarity == "ff0070dd")  then
			Rarity = "ff0070dd";
		elseif (string.lower(Rarity) == "uncommon") or (Rarity == "ff1eff00") then
			Rarity = "ff1eff00";
		elseif (string.lower(Rarity) == "common") or (Rarity == "ffffffff") then
			Rarity = "ffffffff";
		elseif (string.lower(Rarity) == "poor") or (Rarity == "ff9d9d9d") then
			Rarity = "ff9d9d9d";
		else
			Rarity = "";
		end
		
		local MatchAllText, MatchName, MatchRarity, MatchLocation;
		for index, value in ItemLinks do
			if (AllText == "") then
				MatchAllText = true;
			else
				if (string.find(string.lower(ItemLinks[index]["t"]), string.lower(AllText))) then
					MatchAllText = true;
				else
					MatchAllText = false;
				end
			end
			
			if (Name == "") then
				MatchName = true;
			else
				if (string.find(string.lower(index), string.lower(Name))) then
					MatchName = true;
				else
					MatchName = false;
				end
			end			
			
			if (Rarity == "") then
				MatchRarity = true;
			else
				if (Rarity == ItemLinks[index]["c"]) then
					MatchRarity = true;
				else
					MatchRarity = false;
				end
			end
			
			if (Slot == "") then
				MatchLocation = true;
			else
				if (string.find(string.lower(ItemLinks[index]["t"]), string.lower(Slot))) then
					MatchLocation = true;
				else
					MatchLocation = false;
				end
			end
			
			if ((MatchAllText) and (MatchName) and (MatchRarity) and (MatchLocation)) then
				if (GetItemInfo(gb_LLGetHyperlink(index))) then 
					iIterator = iIterator + 1;
					linkarray[iIterator] = gb_LLGetLink(index);
				end
			end
		end
		table.sort (linkarray, gb_LLColorComparison);
		return linkarray, chatchannel, player;
	end
end

function gb_SendResults(linkarray, chatchannel, player)
	local iIterator = 1;
	local jIterator = 0;
	local chatmessage;
	if (linkarray == nil) then
		return;
	end
	while (linkarray[iIterator]) and (iIterator < gb_Options.MaxResults) do
		jIterator = jIterator + 1;
		chatmessage = "";
		
		while (linkarray[iIterator]) and (string.len(chatmessage..linkarray[iIterator]) < 255) do
			chatmessage = chatmessage..linkarray[iIterator];
			iIterator = iIterator + 1;
		end
		
		gb_MessagesToHide = gb_MessagesToHide + 2;
		SendChatMessage(chatmessage, "WHISPER", GetDefaultLanguage("player"), player);
		
	end
end

function gb_Enable()
	gb_Options["enabled"] = true;
	gb_Register();
end

function gb_Disable()
	gb_Options["enabled"] = false;
	gb_Unregister();
end

function gb_AddMsg(msg, noprefix)
	if (not noprefix) then
		DEFAULT_CHAT_FRAME:AddMessage(chat_prefix..msg, 0.0, 0.7, 0.3, 0.7);
	else
		DEFAULT_CHAT_FRAME:AddMessage(msg, 0.0, 0.7, 0.3, 0.7);
	end
end

function gb_Register(ev)
	if (ev == nil) then
		for _, value in gb_Events do
			LootLinkBot:RegisterEvent(value);
		end
	else
		LootLinkBot:RegisterEvent(ev);
	end
end

function gb_Unregister(ev)
	if (ev == nil) then
		for _, value in gb_Events do
			LootLinkBot:RegisterEvent(value);
		end
	else
		LootLinkBot:UnregisterEvent(ev);
	end
end

gb_OriginalChatFrame_OnEvent = ChatFrame_OnEvent;
function ChatFrame_OnEvent(event)
	if (strsub(event,1,23) == "CHAT_MSG_WHISPER_INFORM") then
		local msg = arg1;
		local player = arg2;
		if ((msg) and (player) and (gb_Options["HideMessages"]) and (gb_MessagesToHide > 0) and (string.find(msg, "item:(%d+):0:(%d+):"))) then
			gb_MessagesToHide = gb_MessagesToHide - 1;			
		else			
			gb_OriginalChatFrame_OnEvent(event);	
		end
	else		
		gb_OriginalChatFrame_OnEvent(event);
	end
end

------------------------------------------------**LootLink Functions**------------------------------------------------
function gb_LLGetLink(name)
	local itemLink = ItemLinks[name];
	if (itemLink and itemLink.c and itemLink.i) then
		local link = "|c"..itemLink.c.."|H"..gb_LLGetHyperlink(name).."|h["..name.."]|h|r";
		return link;
	end
	return nil;
end

function gb_LLGetHyperlink(name)
	local itemLink = ItemLinks[name];
	if (itemLink and itemLink.i) then
		-- Remove instance-specific data (enchants) that we captured from the link we return
		local item = string.gsub(itemLink.i, "(%d+):(%d+):(%d+):(%d+)", "%1:0:%3:%4");
		return "item:"..item;
	end
	return nil;
end

function gb_LLColorComparison(elem1, elem2)
	local color1;
	local color2;
	linkcolor1 = "";
	linkcolor2 = "";
	for rarity1 in string.gfind(elem1, "|c(%w+)|Hitem:(.*)") do
		linkcolor1 = rarity1;
	end
	
	for rarity2 in string.gfind(elem2, "|c(%w+)|Hitem:(.*)") do
		linkcolor2 = rarity2;
	end

	color1 = linkcolor1;
	color2 = linkcolor2;
	
--[[	if( ItemLinks[elem1] and ItemLinks[elem1].c ) then
		color1 = ItemLinks[elem1].c;
	else
		color1 = "ffffffff";
	end
	if( ItemLinks[elem2] and ItemLinks[elem2].c ) then
		color2 = ItemLinks[elem2].c;
	else
		color2 = "ffffffff";
	end ]]--
	
	if( color1 == color2 ) then
		return elem1 < elem2;
	end
	
	if( not lColorSortTable[color1] and not lColorSortTable[color2] ) then
		return color1 < color2;
	end
	
	if( lColorSortTable[color1] ) then
		if( lColorSortTable[color2] ) then
			return lColorSortTable[color1] < lColorSortTable[color2];
		end
		return nil;
	end
	return 1;
end